diff --git a/tests/safe/test_config.py b/tests/safe/test_config.py
new file mode 100644
index 0000000..b0e57a0
--- /dev/null
+++ b/tests/safe/test_config.py
@@ -0,0 +1,133 @@
+import sys, pprint, logging, unittest, tempfile
+from pyparsing import ParseException
+from rtslib import config
+
+logging.basicConfig()
+log = logging.getLogger('TestConfig')
+log.setLevel(logging.INFO)
+
+class TestConfig(unittest.TestCase):
+
+    samples_dir = '../data'
+
+    def test_load_basic(self):
+        print
+        log.info(self._testMethodName)
+        filepath = "%s/config_basic.lio" % self.samples_dir
+        lio = config.Config()
+
+        lio.load(filepath)
+
+        tests = [("storage fileio", 'obj', 1),
+                 ("storage fileio disk vm1 path /tmp/vm1.img", 'attr', 1),
+                 ("storage fileio disk vm1 size 1.0MB", 'attr', 1),
+                 ("storage .* disk .* .* .*", 'attr', 3)]
+
+        for pattern, node_type, arity in tests:
+            results = lio.search(pattern)
+            log.debug("config.current.search(%s) -> (%d) %s"
+                      % (pattern, len(results), results))
+            self.failUnless(len(results) == arity)
+            for result in results:
+                self.failUnless(result.data['type'] == node_type)
+
+        self.failUnless(lio.search("storage fileio disk vm1 path") == [])
+
+    def test_load_complete(self):
+        print
+        log.info(self._testMethodName)
+        filepath = "%s/config_complete.lio" % self.samples_dir
+        lio = config.Config()
+        lio.load(filepath)
+
+        tests = [("storage fileio", 'obj', 1),
+                 ("storage fileio disk disk1 path", None, 0),
+                 ("storage fileio disk disk1 path /tmp/disk1.img", 'attr', 1),
+                 ("storage fileio disk disk1 path /tmp/disk2.img", 'attr', 0),
+                 ("storage fileio disk disk1 size 1.0MB", 'attr', 1),
+                 ("storage fileio disk disk2 path /tmp/disk2.img", 'attr', 1),
+                 ("storage .* disk .* .* .* .*", 'attr', 46),
+                 ("storage .* disk .* attribute .* .*", 'attr', 46),
+                 ("storage .* disk .* .* .*", 'attr', 6)]
+
+        for pattern, node_type, arity in tests:
+            results = lio.search(pattern)
+            log.debug("config.current.search(%s) -> (%d) %s"
+                      % (pattern, len(results), results))
+            self.failUnless(len(results) == arity)
+            for result in results:
+                self.failUnless(result.data['type'] == node_type)
+
+    def test_clear_undo(self):
+        print
+        log.info(self._testMethodName)
+        filepath = "%s/config_complete.lio" % self.samples_dir
+        lio = config.Config()
+        log.info("Load config")
+        lio.load(filepath)
+        self.failUnless(len(lio.search("storage fileio disk disk2")) == 1)
+        lio.clear()
+        self.failUnless(len(lio.search("storage fileio disk disk2")) == 0)
+        lio.undo()
+        self.failUnless(len(lio.search("storage fileio disk disk2")) == 1)
+
+    def test_load_save(self):
+        print
+        log.info(self._testMethodName)
+        filepath = "%s/config_complete.lio" % self.samples_dir
+        lio = config.Config()
+        lio.load(filepath)
+
+        with tempfile.NamedTemporaryFile(delete=False) as temp:
+            log.debug("Saving initial config to %s" % temp.name)
+            dump1 = lio.save(temp.name)
+            lio.load(temp.name)
+
+        with tempfile.NamedTemporaryFile(delete=False) as temp:
+            log.debug("Saving reloaded config to %s" % temp.name)
+            dump2 = lio.save(temp.name)
+
+        self.failUnless(dump1 == dump2)
+
+    def test_set_delete(self):
+        print
+        log.info(self._testMethodName)
+        filepath = "%s/config_complete.lio" % self.samples_dir
+
+        lio = config.Config()
+        set1 = lio.search("storage fileio disk mydisk")
+        set2 = lio.search("fabric iscsi discovery_auth enable yes")
+        self.failUnless(len(set1) == len(set2) == 0)
+
+        iqn = '"iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.foo"'
+        lio.set("fabric iscsi target " + iqn)
+        self.assertRaises(ParseException, lio.set,
+                          "fabric iscsi discovery_auth")
+        lio.set("fabric iscsi discovery_auth enable yes")
+        lio.set("storage fileio disk vm1 {path /foo.img; size 1MB;}")
+        self.assertRaises(ParseException, lio.set,
+                          "storage fileio disk vm1 {path /foo.img; size 1MB}")
+        lio.set("storage fileio disk mydisk")
+        set1 = lio.search("storage fileio disk mydisk")
+        set2 = lio.search("fabric iscsi discovery_auth enable yes")
+        self.failUnless(len(set1) == len(set2) == 1)
+
+        lio.delete("storage fileio disk mydisk")
+        lio.delete("fabric iscsi discovery_auth enable yes")
+        set1 = lio.search("storage fileio disk mydisk")
+        set2 = lio.search("fabric iscsi discovery_auth enable yes")
+        self.failUnless(len(set1) == 0)
+        self.failUnless(len(set2) == 0)
+
+    def test_invalid_reference(self):
+        print
+        log.info(self._testMethodName)
+        filepath = "%s/config_invalid_reference.lio" % self.samples_dir
+        lio = config.Config()
+        self.assertRaisesRegexp(config.ConfigError,
+                                ".*Invalid.*disk3.*",
+                                lio.load, filepath)
+        lio = config.Config()
+
+if __name__ == '__main__':
+    unittest.main()
diff --git a/tests/safe/test_config_parser.py b/tests/safe/test_config_parser.py
new file mode 100644
index 0000000..b42c1a7
--- /dev/null
+++ b/tests/safe/test_config_parser.py
@@ -0,0 +1,108 @@
+import sys, pprint, logging, unittest, cPickle
+from rtslib import config_parser
+
+# TODO Add PolicyParser tests
+
+logging.basicConfig()
+log = logging.getLogger('TestConfigParser')
+log.setLevel(logging.INFO)
+
+class TestConfigParser(unittest.TestCase):
+
+    parser = config_parser.ConfigParser()
+    samples_dir = '../data'
+
+    def test_one_line(self):
+        print
+        log.info(self._testMethodName)
+        config = "%s/config_one_line.lio" % self.samples_dir
+        parse_tree = self.parser.parse_file(config)
+        for statement in parse_tree:
+            log.debug(pprint.pformat(statement))
+        # with open("%s.ast" % config[:-4], 'w') as f:
+        #     cPickle.dump(parse_tree, f)
+        with open("%s.ast" % config[:-4], 'r') as f:
+            expected_tree = cPickle.load(f)
+        self.failUnless(parse_tree == expected_tree)
+
+    def test_basic(self):
+        print
+        log.info(self._testMethodName)
+        config = "%s/config_basic.lio" % self.samples_dir
+        parse_tree = self.parser.parse_file(config)
+        for statement in parse_tree:
+            log.debug(pprint.pformat(statement))
+        # with open("%s.ast" % config[:-4], 'w') as f:
+        #     cPickle.dump(parse_tree, f)
+        with open("%s.ast" % config[:-4], 'r') as f:
+            expected_tree = cPickle.load(f)
+        self.failUnless(parse_tree == expected_tree)
+    
+    def test_attribute_group(self):
+        print
+        log.info(self._testMethodName)
+        config = "%s/config_attribute_group.lio" % self.samples_dir
+        parse_tree = self.parser.parse_file(config)
+        for statement in parse_tree:
+            log.debug(pprint.pformat(statement))
+        # with open("%s.ast" % config[:-4], 'w') as f:
+        #     cPickle.dump(parse_tree, f)
+        with open("%s.ast" % config[:-4], 'r') as f:
+            expected_tree = cPickle.load(f)
+        self.failUnless(parse_tree == expected_tree)
+
+    def test_nested_blocks(self):
+        print
+        log.info(self._testMethodName)
+        config = "%s/config_nested_blocks.lio" % self.samples_dir
+        parse_tree = self.parser.parse_file(config)
+        for statement in parse_tree:
+            log.debug(pprint.pformat(statement))
+        # with open("%s.ast" % config[:-4], 'w') as f:
+        #     cPickle.dump(parse_tree, f)
+        with open("%s.ast" % config[:-4], 'r') as f:
+            expected_tree = cPickle.load(f)
+        self.failUnless(parse_tree == expected_tree)
+
+    def test_comments(self):
+        print
+        log.info(self._testMethodName)
+        config = "%s/config_comments.lio" % self.samples_dir
+        parse_tree = self.parser.parse_file(config)
+        for statement in parse_tree:
+            log.debug(pprint.pformat(statement))
+        # with open("%s.ast" % config[:-4], 'w') as f:
+        #     cPickle.dump(parse_tree, f)
+        with open("%s.ast" % config[:-4], 'r') as f:
+            expected_tree = cPickle.load(f)
+        self.failUnless(parse_tree == expected_tree)
+
+    def test_strings(self):
+        print
+        log.info(self._testMethodName)
+        config = "%s/config_strings.lio" % self.samples_dir
+        parse_tree = self.parser.parse_file(config)
+        for statement in parse_tree:
+            log.debug(pprint.pformat(statement))
+        # with open("%s.ast" % config[:-4], 'w') as f:
+        #     cPickle.dump(parse_tree, f)
+        with open("%s.ast" % config[:-4], 'r') as f:
+            expected_tree = cPickle.load(f)
+        self.failUnless(parse_tree == expected_tree)
+
+    def test_complete(self):
+        print
+        log.info(self._testMethodName)
+        config = "%s/config_complete.lio" % self.samples_dir
+        parse_tree = self.parser.parse_file(config)
+        for statement in parse_tree:
+            log.debug(pprint.pformat(statement))
+        # with open("%s.ast" % config[:-4], 'w') as f:
+        #     cPickle.dump(parse_tree, f)
+        with open("%s.ast" % config[:-4], 'r') as f:
+            expected_tree = cPickle.load(f)
+
+        self.failUnless(parse_tree == expected_tree)
+
+if __name__ == '__main__':
+    unittest.main()
diff --git a/tests/safe/test_config_tree.py b/tests/safe/test_config_tree.py
new file mode 100644
index 0000000..cadc296
--- /dev/null
+++ b/tests/safe/test_config_tree.py
@@ -0,0 +1,101 @@
+import re, sys, pprint, logging, unittest
+from rtslib import config_tree
+
+logging.basicConfig()
+log = logging.getLogger('TestConfigTree')
+log.setLevel(logging.INFO)
+
+class TestConfigTree(unittest.TestCase):
+
+    def test_create(self):
+        print
+        log.info(self._testMethodName)
+        tree = config_tree.ConfigTree()
+        self.failUnless(tree.get(None) is None)
+        self.failUnless(tree.get_path(None) is None)
+        self.failUnless(tree.get_path([]) is None)
+        self.failUnless(tree.get(()) is None)
+        self.failUnless(tree.delete(None) is None)
+        self.failUnless(tree.get_path(('a',)) is None)
+        self.failUnless(tree.get_path([('a',), ('b',), ('c',)]) is None)
+
+    def test_add_get_delete(self):
+        print
+        log.info(self._testMethodName)
+        tree = config_tree.ConfigTree()
+        n1 = tree.set(('1', '2'), {'info': 'n1'})
+        nA = tree.set(('a', 'b'), {'info': 'nA'})
+        n2 = n1.set(('3', '4'), {'info': 'n2'})
+        nB = nA.set(('c', 'd'), {'info': 'nB'})
+
+        node = tree.get([('1', '2'), ('3', '4')])
+        self.failUnless(node.data['info'] == 'n2')
+        node = tree.get([('1', '2')])
+        self.failUnless(node.data['info'] == 'n1')
+        node = tree.get([('a', 'b'), ('c', 'd')])
+        self.failUnless(node.data['info'] == 'nB')
+        self.failUnless(node.is_root == False)
+        self.failUnless(tree.is_root == True)
+
+    def test_add_get_delete(self):
+        print
+        log.info(self._testMethodName)
+        tree = config_tree.ConfigTree()
+        n1 = tree.set(('1', '2'), {'info': 'n1'})
+        nA = tree.set(('a', 'b'), {'info': 'nA'})
+        n2 = n1.set(('3', '4'), {'info': 'n2'})
+        nB = nA.set(('c', 'd'), {'info': 'nB'})
+        log.debug("root path: %s" % tree.path)
+        log.debug("Node [1 2] path: %s" % n1.path)
+        log.debug("Node [1 2 3 4] path: %s" % n2.path)
+        log.debug("Node [a b] path: %s" % nA.path)
+        log.debug("Node [a b c d] path: %s" % nB.path)
+
+    def test_search(self):
+        print
+        log.info(self._testMethodName)
+        tree = config_tree.ConfigTree()
+        fileio = tree.set(('storage', 'fileio'))
+        fileio.set(('disk', 'vm1'))
+        fileio.set(('disk', 'vm2'))
+        fileio.set(('disk', 'test1'))
+        fileio.set(('disk', 'test2'))
+        iblock = tree.set(('storage', 'iblock'))
+        iblock.set(('disk', 'vm3'))
+        iblock.set(('disk', 'vm4'))
+        iblock.set(('disk', 'test1'))
+        iblock.set(('disk', 'test2'))
+
+        tests = [([("storage", ".*"), ("disk", "vm1")], 1),
+                 ([("storage", ".*"), ("disk", "vm2")], 1),
+                 ([("storage", ".*"), ("disk", "vm1")], 1),
+                 ([("storage", "fileio"), ("disk", "vm[0-9]")], 2),
+                 ([("storage", "file.*"), ("disk", "vm[0-9]")], 2),
+                 ([("storage", ".*"), ("disk", "vm[0-9]")], 4),
+                 ([("storage", ".*"), ("disk", ".*[12]")], 6),
+                 ([("storage", ".*"), ("disk", ".*")], 8)]
+
+        for search_path, arity in tests: 
+            nodes = tree.search(search_path)
+            self.failUnless(len(nodes) == arity)
+
+        log.debug("Deleting iblock subtree")
+        for node in tree.search([(".*", "iblock")]):
+            tree.delete(node.path)
+
+        tests = [([(".*", ".*"), ("disk", "vm1")], 1),
+                 ([(".*", ".*"), ("disk", "vm2")], 1),
+                 ([("storage", ".*"), ("disk", "vm1")], 1),
+                 ([(".*", "fileio"), ("disk", "vm[0-9]")], 2),
+                 ([(".*", "file.*"), ("disk", "vm[0-9]")], 2),
+                 ([(".*", ".*"), ("disk", "vm[0-9]")], 2),
+                 ([(".*", ".*"), (".*", ".*[12]")], 4),
+                 ([(".*", ".*"), (".*", ".*")], 4)]
+
+        for search_path, arity in tests: 
+            nodes = tree.search(search_path)
+            log.debug("search(%s) ->  %s" % (search_path, nodes))
+            self.failUnless(len(nodes) == arity)
+
+if __name__ == '__main__':
+    unittest.main()
diff --git a/tests/system/test_dump_restore.py b/tests/system/test_dump_restore.py
new file mode 100644
index 0000000..f7c5e87
--- /dev/null
+++ b/tests/system/test_dump_restore.py
@@ -0,0 +1,82 @@
+import os, sys, logging, unittest, tempfile, difflib, rtslib
+from pyparsing import ParseException
+
+logging.basicConfig()
+log = logging.getLogger('TestDumpRestore')
+log.setLevel(logging.INFO)
+
+def diffs(a, b):
+    differ = difflib.Differ()
+    context = []
+    result = []
+
+    for line in differ.compare(a.splitlines(), b.splitlines()):
+        if line[0] in "+-":
+            result.extend(context[-5:])
+            result.append(line)
+        elif line[0] == "?":
+            result.append(line[:-1])
+            context = []
+        else:
+            context.append(line)
+    return '\n'.join(result)
+
+class TestDumpRestore(unittest.TestCase):
+
+    samples_dir = '../data'
+
+    def setUp(self):
+        self.config_backup = rtslib.Config()
+        self.config_backup.load_live()
+        print
+        log.info(self._testMethodName)
+
+    def tearDown(self):
+        print("Restoring initial config...")
+        for step in self.config_backup.apply():
+            print(step)
+
+    def test_load_apply_config(self):
+        filepath = "%s/config_ramdisk_fileio_iscsi.lio" % self.samples_dir
+        config = rtslib.Config()
+        config.load(filepath)
+        for step in config.apply():
+            print(step)
+
+    def test_clear_apply_config(self):
+        config = rtslib.Config()
+        config.verify()
+        for step in config.apply():
+            print(step)
+
+    def test_config_samples(self):
+        samples = ["%s/%s" % (self.samples_dir, name)
+                   for name in sorted(os.listdir(self.samples_dir))
+                   if name.startswith("config_sample_")
+                   if name.endswith(".lio")]
+        for sample in samples:
+            with open(sample) as fd:
+                orig = fd.read()
+
+            config = rtslib.Config()
+            print("Loading %s" % sample)
+            config.load(sample)
+            diff =  diffs(orig, config.dump())
+            print(diff)
+            self.failIf(diff)
+
+            print("Verifying %s" % sample)
+            config.verify()
+            print("Applying %s" % sample)
+            for step in config.apply():
+                print(step)
+
+            config = rtslib.Config()
+            print("Reloading %s from live" % sample)
+            config.load_live()
+            diff =  diffs(orig, config.dump())
+            print(diff)
+            self.failIf(diff)
+
+if __name__ == '__main__':
+    unittest.main()
